.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm

	LOOP_COUNT = 10000000

.data?
m32a	dd ?
m32b	dd ?

.code
start:
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  push eax
		  pop ecx
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*(push eax+pop ecx)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  push eax
		  pop eax
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*(push eax+pop eax)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  push eax
		ENDM
		REPEAT 8
		  pop ecx
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*push eax, n*pop ecx", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  push eax
		  pop m32a
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*(push eax+pop m32a)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  push eax
		ENDM
		REPEAT 8
		  pop m32a
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*push eax, n*pop m32a", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  push m32a
		  pop m32b
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*(push m32a+pop m32b)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  push m32a
		ENDM
		REPEAT 8
		  pop m32b
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*push m32a, n*pop m32b", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  pushad
		  popad
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*(pushad+popad)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 8
		  pushad
		ENDM
		REPEAT 8
		  popad
		ENDM
	counter_end
	shr eax, 3
	print str$(eax), 9, "cycles for n*pushad, n*popad", 13, 10

	exit
end start
OPT_Tmp2Asm	1
